<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>Context-Free Pumping Lemmas</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 1.1.5  (Linux)">
	<META NAME="CREATED" CONTENT="20070726;19161100">
	<META NAME="CHANGED" CONTENT="20070803;16283400">
	<STYLE>
	<!--
		@page { size: 8.5in 11in }
	-->
	</STYLE>
</HEAD>
<BODY LANG="en-US" DIR="LTR">
<H1>Context-Free Pumping Lemmas</H1>
<H2>Contents</H2>
<P><A HREF="#definition">Definition</A><BR><A HREF="#game">Explaining
the Game</A><BR><A HREF="#start">Starting the Game</A><BR><A HREF="#user">User
Goes First</A><BR><A HREF="#computer">Computer Goes First</A> 
</P>
<P>This game approach to the pumping lemma is based on the approach
in Peter Linz's <I>An Introduction to Formal Languages and Automata</I>.
</P>
<P>Before continuing, it is recommended that if you read the tutorial
for <A HREF="../regular/index.html">regular pumping lemmas</A> if you
haven't already done so. It explains many of the basics of the game,
both when the user goes first and when the computer goes first. This
tutorial will primarily focus on those features which differentiate
between context-free and regular pumping lemmas.</P>
<H2><A NAME="definition"></A>Definition</H2>
<P>JFLAP defines a context-free pumping lemma to be the following.
Let <I>L</I> be an infinite context-free language. Then there exists
some positive integer <I>m</I> such that any <I>w</I> that is a
member of<!--&#8712;--><!--element of--> <I>L</I> with |<I>w</I>| ≥<!--greater than or equal-->
<I>m</I> can be decomposed as 
</P>
<P ALIGN=CENTER><I>w</I> = <I>uvxyz</I>, 
</P>
<P>with 
</P>
<P ALIGN=CENTER>|<I>vxy</I>| ≤<!--less than or equal--> <I>m</I>, 
</P>
<P>and 
</P>
<P ALIGN=CENTER>|<I>vy</I>| ≥<!--greater than or equal--> 1, 
</P>
<P>such that 
</P>
<P ALIGN=CENTER><I>w<SUB>i</SUB></I> = <I>uv<SUP>i</SUP>xy<SUP>i</SUP>z</I>,
</P>
<P>is also in <I>L</I> for all <I>i</I> = 0, 1, 2, .... 
</P>
<H2><A NAME="game"></A>Explaining the Game</H2>
<P>JFLAP treats the context-free pumping lemma in a two-player game.
In the game below, Player A is trying to find a <I>uvxyz</I>
decomposition that is always in the language no matter what the <I>i</I>
value is. If player B can pick a strategy such that he or she will
always win regardless of player A's choices, meaning that no adequate
decomposition exists, it is equivalent to proof that the language is
not context-free. The game is played like this: 
</P>
<OL>
	<LI><P STYLE="margin-bottom: 0in">Player A picks an integer for <I>m</I>.
		</P>
	<LI><P STYLE="margin-bottom: 0in">Player B picks a string <I>w</I>
	such that <I>w</I> is a member of<!--&#8712;--><!--element of--> <I>L</I>
	and |<I>w</I>| ≥<!--greater than or equal--> <I>m</I>. 
	</P>
	<LI><P STYLE="margin-bottom: 0in">Player A picks the partition of <I>w</I>
	into <I>uvxyz</I> such that |<I>vxy</I>| ≥ <I>m</I> and |<I>vy</I>|
	≥ 1. 
	</P>
	<LI><P>Player B picks an integer <I>i</I> such that <I>uv<SUP>i</SUP>xy<SUP>i</SUP>z</I>
	is not a member of<!--&#8713--><!--not element of--> <I>L</I>. If
	player B can do so player B wins, otherwise, player A wins. 
	</P>
</OL>
<P>There are two possible modes for the game, when the user goes
first and when the computer goes first. In the first mode, the user
is player A and the computer is player B, and thus the user should be
trying to find an acceptable decomposition to pump. In the second
mode, the user is player B and the computer is player A, and thus the
user should be trying to prevent the computer from generating a valid
decomposition.</P>
<H2><A NAME="start"></A>Starting the Game</H2>
<P>To start a context-free pumping lemma game, select <B>Context-Free
Pumping Lemma</B> from the main menu: 
</P>
<P ALIGN=CENTER><IMG SRC="images/menu" NAME="Graphic1" ALIGN=MIDDLE WIDTH=233 HEIGHT=321 BORDER=0></P>
<P>The following screen should come up. It has the same functionality
as the corresponding screen for regular pumping lemmas, except this
time it includes some languages which are context-free and some that
are not.</P>
<P ALIGN=CENTER><IMG SRC="images/chooser" NAME="Graphic2" ALIGN=MIDDLE WIDTH=800 HEIGHT=780 BORDER=0></P>
<H2><A NAME="user"></A>User Goes First</H2>
<P>Let's do an example for when the user goes first. Since the “You
go first” option is already selected, we do not need to do anything
in the top panel. Now, let's choose the first language in the list, L
= {a<SUP>n</SUP>b<SUP>n</SUP>c<SUP>n,</SUP> : n ≥ 0}. Go ahead and
press the “Select” button to the right of the language. The
following screen should come up.</P>
<P ALIGN=CENTER><IMG SRC="images/humanintro" NAME="Graphic3" ALIGN=MIDDLE WIDTH=800 HEIGHT=780 BORDER=0></P>
<P ALIGN=LEFT>You may notice that the left panel resembles the screen
that we used for regular pumping lemmas. You may also wonder about
the right panel, which is the case panel. Not all the languages
listed use this panel, and the left panel takes up the whole screen
for those that do not. However, this one does utilize it, and we will
interact with it in time. First, however, play the game that is
identical to the one played with regular pumping lemmas, except that
instead of composing into <I>xyz</I> you will decompose into <I>uvxyz</I>.
Use a value of 3 for <I>m</I> and a decomposition of <I>u</I> = “aa”,
<I>v</I> = “a”, <I>x</I> = “b”, <I>y </I>= ”b”, and <I>z</I>
= “bccc”. When finished, your screen should resemble the one
below.</P>
<P ALIGN=CENTER><IMG SRC="images/userattempt1" NAME="Graphic4" ALIGN=MIDDLE WIDTH=800 HEIGHT=780 BORDER=0></P>
<P ALIGN=LEFT>We failed to find an adequate decomposition this time.
However, we have checked one possible case for out decomposition,
which is when <I>v</I> has at least one “a” and “b” and when
<I>y</I> has a “b”. In many of the context-free languages
supported by JFLAP (although not all of them), the languages support
the storage and implementation of cases. This language is one of
them. Thus, we can add the case that we have chosen to the case panel
on the right. Click on the “Add” button, and a new line
representing this case should become visible in the right panel.</P>
<P ALIGN=CENTER><IMG SRC="images/usercase1" NAME="Graphic4" ALIGN=MIDDLE WIDTH=373 HEIGHT=72 BORDER=0></P>
<P ALIGN=LEFT>You should also notice that all the buttons at the
bottom of the case panel are now visible. What each button does is as
follows: 
</P>
<UL>
	<LI><P STYLE="margin-bottom: 0in">“Add” will add the current
	attempt to the case panel if the attempt represents a new case. If
	the case is already listed in the case panel, you are informed with
	a message in the text box above the buttons that that case resembles
	an existing case in the panel (telling you the number). 
	</P>
	<LI><P>“Replace” will replace the attempt stored in the
	highlighted case with the current attempt. Since there is only one
	case at present, it is already highlighted, but if there were more,
	you can highlight them by clicking on the relevant case with the
	mouse. If the current attempt is an invalid example of a particular
	case, you will be informed of that fact.</P>
	<LI><P>“Show” will show on the left panel the current attempt
	stored in the highlighted case.</P>
	<LI><P>“Delete” will remove the highlighted case from the case
	panel.</P>
	<LI><P>“Clear” will remove all cases from the case panel.</P>
	<LI><P>“Done?” will inform you either how many cases are absent
	from the case panel or whether all cases are present. 
	</P>
	<LI><P>“List” will list all the cases that have yet to be
	generated, with preset attempts stored in them.</P>
</UL>
<P>Certain buttons will be visible at different times, depending on
whether an action is legal at that moment in time. Also note that if
you choose a new <I>m </I>value, then all cases will be removed from
the panel. This is due to the fact that the stored attempts may no
longer be valid with a new <I>w</I> string. One should also note that
if a case example does not generate a valid partition, then all
examples of that case will not necessarily do likewise. It is
possible, but not for every language, so one must use intuition
before generalizing one example to an entire case.</P>
<P>Below is the screen for when all eleven cases in this language are
present in the case panel. The file with this screen present is
stored in <A HREF="cfUserFirst.jff">cfUserFirst.jff.</A></P>
<P ALIGN=CENTER><IMG SRC="images/usercasesall" NAME="Graphic4" ALIGN=MIDDLE WIDTH=800 HEIGHT=780 BORDER=0></P>
<H2><A NAME="computer"></A>Computer Goes First</H2>
<P ALIGN=LEFT>Context-free pumping lemmas when the computer goes
first have similar functionality to the corresponding regular pumping
lemma mode, except with a <I>uvxyz</I> decomposition. No cases are
used for when the computer goes first, as it is rarely optimal for
the computer to choose a decomposition based on cases. Thus, the case
panel will never be present.</P>
<P ALIGN=LEFT STYLE="margin-bottom: 0in; font-style: normal"><B>This
concludes our brief tutorial on context-free pumping lemmas. Thanks
for reading!</B></P>
</BODY>
</HTML>